package com.yoyodyne.ejbs;

import com.yoyodyne.entities.Bar;
import com.yoyodyne.entities.Foo;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;

@Stateless
public class FoobarEjb implements FoobarLocal {

	@PersistenceContext(unitName = "pu9") private EntityManager em;

	public void createFoo(String id, String name) {
		Foo foo = new Foo();
		foo.setId(id);
		foo.setName(name);
		em.persist(foo);
	}

	public void createBar(String name) {
		Bar bar = new Bar();
		bar.setName(name);
		em.persist(bar);
	}

	public void deleteFoo(String id) {
		Foo foo = em.find(Foo.class, id);
		em.remove(foo);
	}

	public void deleteBar(int id) {
		Bar bar = em.find(Bar.class, id);
		em.remove(bar);
	}

	@SuppressWarnings("unchecked")
	public List<Foo> findAllFoos() {
		Query query = em.createQuery("SELECT x FROM Foo x");
		return (List<Foo>) query.getResultList();
	}

	@SuppressWarnings("unchecked")
	public List<Bar> findAllBars() {
		Query query = em.createQuery("SELECT x FROM Bar x");
		return (List<Bar>) query.getResultList();
	}

	public void addBar(String fooId, int barId) {
		System.out.println("--- begin add Bar ---");
		Foo foo = em.find(Foo.class, fooId);
		Bar bar = em.find(Bar.class, barId);
		foo.getBars().add(bar);
		bar.getFoos().add(foo);
		System.out.println("--- end add Bar ---");
	}

	public void removeBar(String fooId, int barId) {
		System.out.println("--- begin remove Bar ---");
		Foo foo = em.find(Foo.class, fooId);
		Bar bar = em.find(Bar.class, barId);
		foo.getBars().remove(bar);
		bar.getFoos().remove(foo);
		System.out.println("--- end remove Bar ---");
	}

	public void removeAllFoos(int barId) {
		System.out.println("--- begin remove all Foos ---");
		Bar bar = em.find(Bar.class, barId);
		for (Foo foo : bar.getFoos())
			foo.getBars().remove(bar);
		bar.getFoos().clear();
		System.out.println("--- end remove all Foos ---");
	}

	public void addAllFoos(int barId) {
		System.out.println("--- begin add all Foos ---");
		Bar bar = em.find(Bar.class, barId);
		for (Foo foo : findAllFoos()) {
			foo.getBars().add(bar);
			bar.getFoos().add(foo);
		}
		System.out.println("--- end add all Foos ---");
	}

	// Leaves no entries for barId in the table foo_bar!

	public void flummox(int barId) {
		System.out.println("--- begin flummox ---");
		removeAllFoos(barId);
		addAllFoos(barId);
		System.out.println("--- end flummox ---");
	}	
}
